; Bin2ToHex4
; ==========
; wandelt eine 24-Bit-Binrzahl in Hex-ASCII
; Rckkehr: Z zeigt auf erste Position des vierstelligen
;   ASCII-Hex, ASCII-Ziffern A..F in Grobuchstaben
Freq2Hex:
	LDI	ZH,	HIGH(STR6)
	LDI	ZL,	LOW(STR6)
	mov TEMP,FREQ_H ; MSB in rmp kopieren
	rcall Bin1ToHex2 ; in Hex-ASCII umwandeln
	mov TEMP,FREQ_M ; LSB in rmp kopieren
	rcall Bin1ToHex2 ; in Hex-ASCII umwandeln
	mov TEMP,FREQ_L ; LSB in rmp kopieren
	rcall Bin1ToHex2 ; in Hex-ASCII umwandeln
	sbiw ZL,6 ; Zeiger auf Anfang Hex-ASCII
	ret ; fertig
;
; Bin1ToHex2 wandelt die 8-Bit-Binrzahl in rmp in Hex-ASCII
Bin1ToHex2:
	push TEMP ; Rette Byte auf dem Stapel
	swap TEMP ; Vertausche die oberen und unteren 4 Bit
	rcall Bin1ToHex1 ; wandle untere 4 Bits in Hex-ASCII
	pop TEMP ; Stelle das Byte wieder her
Bin1ToHex1:
	andi TEMP,$0F ; Maskiere die oberen vier Bits
	subi TEMP,-'0' ; Addiere ASCII-0
	cpi  TEMP,'9'+1 ; Ziffern A..F?
	brcs Bin1ToHex1a ; Nein
	subi TEMP,-7 ; Addiere 7 fr A..F
Bin1ToHex1a:
	st z+,TEMP ; abspeichern und Zeiger erhhen
	ret ; fertig
