UART_TX:
	; Wait for empty transmit buffer
	sbis UCSRA,UDRE
		rjmp UART_TX
	; Put data (r16) into buffer, sends the data
	out UDR,TEMP
	;RCALL	Display_DATA
	ret

UART_RX:
	CLI
	PUSH	TEMP
	PUSH	TEMP1
	PUSH	TEMP2
	IN TEMP,SREG
	PUSH	TEMP
	
	in		TEMP,UDR			; get the byte

	CPI		TEMP,'F'
	BRNE	RX_SKIP
	RCALL	Read_4
	RX_SKIP:
	POP	TEMP
	OUT SREG,TEMP
	POP	TEMP2
	POP	TEMP1
	POP	TEMP
	SEI
	RETI

; 
; read in 4 characters from the serial link
;
get_char:
		sbis 	UCSRA, RXC
			rjmp	get_char		; no, wait some more
		in		r16,UDR			; get the byte
		ret						; and return
read_4:
		rcall	get_char		; read bits 23..16
		mov		FREQ_H,r16
		rcall	get_char		; read bits 15..8
		mov		FREQ_M,r16
		rcall	get_char		; read bits 7..0
		mov		FREQ_L,r16
		
		; Generate PhaseDelta
		;LDI		TEMP, $00
		;MOV		dvd24H, temp
		;MOV		dvd24M, temp
		;MOV		dvd24L, r29
		;MOV		dvr24H, temp
		;MOV		dvr24M, temp
		;MOV		dvr24L, r30
		;RCALL	div24u // first division r29/r30
		;MOV		dvr24H, temp
		;MOV		dvr24M, temp
		;MOV		dvr24L, r31
		;RCALL	div24u // second division result/r31

        ;F42400 = 16MHz
		; jetzt noch delta anzeigen am display
		;RCALL	SHOW_PHASE

		RET
